#!/usr/bin/tclsh

set racenr_2_racename_mapping {
    @@race0@@       Human
    @@race1@@       Drengin
    @@race2@@       Altarian
    @@race3@@       Arcean
    @@race4@@       Torian
    @@race5@@       Yor
    @@race6@@       Korx
    @@race7@@       Drath
    @@race8@@       Thalan
    @@race9@@       Iconian
    @@race10@@      Generic
    @@race11@@      Dreadlords
}

set f [open GC2_Conversations.xml r]
fconfigure $f -translation {crlf crlf}
set content [read $f]
close $f

#
# STEP 1: Convert...
#            <Speaker>1</Speaker>
#            <Listener>2</Listener>
#
# ... to ...
#            <Speaker Name="@@race1@@">1</Speaker>
#            <Listener Name="@@race2@@">2</Listener>
#

set content [regsub -nocase -all {<(Speaker|Listener)>([0-9]+)</(Speaker|Listener)>} $content {<\1 Name="@@race\2@@">\2</\3>}]

#
# STEP 2: Convert...
#            <Speaker Name="@@race1@@">1</Speaker>
#            <Listener Name="@@race2@@">2</Listener>
#
# ... to ...
#            <Speaker Name="Drengin">1</Speaker>
#            <Listener Name="Altarian">2</Listener>
#
set content [string map $racenr_2_racename_mapping $content]

#
# Step 3: Convert...
#            <Phrase>
#                <Morality>2</Morality>
# ... to ...
#                <Phrase Morality="2">
#
#
set content [regsub -nocase -all {<Phrase>[[:blank:]\n]*<Morality>([0-9]+)</Morality>} $content {<Phrase Morality="\1">}]

#
# Step 4: Convert file header
#
set content [regsub -nocase {<Topics>([[:blank:]\n]*)<Topic} $content {<Topics>\1<Translate NoParse="1">Text</Translate>\1<MaxNumRacesInFile>15</MaxNumRacesInFile>\1<Topic}]

set f [open GC2_Conversations_converted.xml w+]
fconfigure $f -translation {crlf crlf}
puts -nonewline $f $content
close $f
